DROP TABLE IF EXISTS public.network_stops;

CREATE TABLE public.network_stops (
  id         serial,
  zones      varchar(100),
  node_point geometry(Point,28356)
);

INSERT INTO public.network_stops (zones,node_point) 
SELECT REPLACE(REPLACE(zones,',(null)',''),'(null),',''), node_point
  FROM (SELECT node_point,
               string_agg(distinct COALESCE(CAST(f.zone_name as varchar(100)),'(null)'),',') as zones
          FROM (SELECT zone_name, ST_SnapToGrid(ST_StartPoint(ST_GeometryN(geom,1)),0.001) as node_point 
                  FROM public.network AS a 
                UNION ALL
                SELECT zone_name, ST_SnapToGrid(ST_EndPoint(ST_GeometryN(geom,1)),0.001) as node_point 
                  FROM public.network AS b
               ) as f
         GROUP By node_point
       ) as g
 WHERE zones <> '(null)' 
   AND zones LIKE '%,%';

ALTER TABLE public.network_stops ADD CONSTRAINT network_stops_pk PRIMARY KEY (id);

CREATE INDEX network_stops_node_sx ON public.network_stops USING GIST (node_point);

ALTER TABLE public.network_stops CLUSTER ON network_stops_node_sx;

--vacuum analyze verbose public.network_stops;
-- 28 live rows 
